#ifndef _BYTESEX_H
#define _BYTESEX_H

static inline uint16_t _constfn sys_bswap16(uint16_t x)
{
	return (uint16_t)(
		(((uint16_t)(x) & (uint16_t)0x00ffU) << 8) |
	 	(((uint16_t)(x) & (uint16_t)0xff00U) >> 8));
}

static inline uint32_t _constfn sys_bswap32(uint32_t x)
{
	return (uint32_t)(
		(((uint32_t)(x) & (uint32_t)0x000000ffUL) << 24) |
		(((uint32_t)(x) & (uint32_t)0x0000ff00UL) <<  8) |
		(((uint32_t)(x) & (uint32_t)0x00ff0000UL) >>  8) |
		(((uint32_t)(x) & (uint32_t)0xff000000UL) >> 24));
}

#if _BYTE_ORDER == _BIG_ENDIAN
#define sys_le32(x) sys_bswap32(x)
#define sys_le16(x) sys_bswap16(x)
#define sys_be32(x) (x)
#define sys_be16(x) (x)
#elif _BYTE_ORDER == _LITTLE_ENDIAN
#define sys_le32(x) (x)
#define sys_le16(x) (x)
#define sys_be32(x) sys_bswap32(x)
#define sys_be16(x) sys_bswap16(x)
#else
#error "What in hells name?!"
#endif

#endif /* _BYTESEX_H */
