/*
 * This file is part of dotscara
 * Copyright (c) 2004 Gianni Tedesco
 * Released under the terms of the GNU GPL version 2
 */
#ifndef _FDCTL_HEADER_INCLUDED_
#define _FDCTL_HEADER_INCLUDED_

#define FDCTL_NONBLOCK		0x01UL
#define FDCTL_COE		0x02UL
#define FDCTL_ANY		BITMASK_ANY

/* Internal APIs */
int _private _fd_read(int fd, void *buf, size_t *sz, int *eof)
	_nonull(2,3,4) _check_result;
int _private _fd_write(int fd, const void *buf, size_t len)
	_nonull(2) _check_result;
int _private _fd_close(int fd);
int _private iowait_single_fd(int fd, int flags);


/* External APIs */
int _public fd_read(int fd, void *buf, size_t *sz, int *eof)
	_nonull(2,3,4) _check_result;
int _public fd_write(int fd, const void *buf, size_t len)
	_nonull(2) _check_result;
int _public fd_close(int fd);

int _public fdctl_block(int fd, int b);
int _public fdctl_coe(int fd, int coe);

int _public sig_pipeignore(void);
int _public socket_nonblock(int s);

#endif /* _FDCTL_HEADER_INCLUDED_ */
