#ifndef _LZHL_H
#define _LZHL_H

#define LZMIN 4
#define LZTABLEBITS 15
#define LZTABLESIZE (1<<(LZTABLEBITS))

#define LZGROUPS 16
#define LZBUFBITS 16
#define LZBUFSIZE (1<<(LZBUFBITS))
#define LZBUFMASK ((LZBUFSIZE) - 1)

#define NHUFFSYMBOLS 274

struct lzhl_group {
	int nBits;
	int pos;
};

struct lzhl {
	uint32_t bits;
	int nBits;
	uint8_t buf[LZBUFSIZE];
	int bufpos;
	struct lzhl_group groupTable[LZGROUPS];
	int16_t symbolTable[NHUFFSYMBOLS];
	int16_t stat[NHUFFSYMBOLS];
};

struct lzhl *lzhl_init(void);
int lzhl_decompress(struct lzhl *lz, uint8_t *dst, size_t *dstSz,
			const uint8_t *src, size_t *srcSz);
void lzhl_free(struct lzhl *lz);
#endif /* _LZHL_H */
