#ifndef _PIGGY_H
#define _PIGGY_H

#if HAVE_CONFIG_H
#include <config.h>
#endif

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include <compiler.h>
#include <bytesex.h>
#include <list.h>

struct nbio;
struct iothread;

typedef void(*listener_cbfn_t)(struct iothread *t, int s, void *priv)
				_nonull(1);
struct nbio *listener_new(uint32_t addr, uint16_t port,
				listener_cbfn_t cb, void *priv)
				_nonull(3);
void listener_add(struct iothread *t, struct nbio *io) _nonull(1,2);

struct proxy_args {
	uint32_t addr;
	uint16_t port;
};

void proxy_new(struct iothread *t, int s, void *priv);
void ssl_proxy_new(struct iothread *t, int s, void *priv);
int ssl_proxy_init(void);

#endif /* _PIGGY_H */
